package sun.net.util;

import java.net.URLPermission;
import java.io.IOException;
import java.security.Permission;
import java.net.URL;

public class URLUtil
{
    public URLUtil() {
    }
    
    public static String urlNoFragString(URL url) {
        StringBuilder sb = new StringBuilder();
        String protocol = url.getProtocol();
        if (protocol != null) {
            sb.append(protocol.toLowerCase());
            sb.append("://");
        }
        String host = url.getHost();
        if (host != null) {
            sb.append(host.toLowerCase());
            int i = url.getPort();
            if (i == -1) {
                i = url.getDefaultPort();
            }
            if (i != -1) {
                sb.append(":").append(i);
            }
        }
        String file = url.getFile();
        if (file != null) {
            sb.append(file);
        }
        return sb.toString();
    }
    
    public static Permission getConnectPermission(URL url) throws IOException {
        String lowerCase = url.toString().toLowerCase();
        if (lowerCase.startsWith("http:") || lowerCase.startsWith("https:")) {
            return getURLConnectPermission(url);
        }
        if (lowerCase.startsWith("jar:http:") || lowerCase.startsWith("jar:https:")) {
            String string = url.toString();
            int index = string.indexOf("!/");
            return getURLConnectPermission(new URL(string.substring(4, (index > -1) ? index : string.length())));
        }
        return url.openConnection().getPermission();
    }
    
    private static Permission getURLConnectPermission(URL url) {
        return new URLPermission(url.getProtocol() + "://" + url.getAuthority() + url.getPath());
    }
}
